﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace CustomerSortComparer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = CreateProducts();
            UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands[0];

            // Assign an instance of IComparer to SortComparer property.
            band.Columns[3].SortComparer = new MySortComparer();

            // Sort the column ascending.
            band.SortedColumns.Add(band.Columns[3], false);
            ultraGrid1.DisplayLayout.Override.GroupByColumnsHidden = DefaultableBoolean.False;

            ValueList v_list = new ValueList();
            v_list.ValueListItems.Add(new ValueListItem(1, "Beverages"));
            v_list.ValueListItems.Add(new ValueListItem(2, "Condiments"));
            v_list.ValueListItems.Add(new ValueListItem(3, "Confections"));
            v_list.ValueListItems.Add(new ValueListItem(4, "Dairy Products"));
            v_list.ValueListItems.Add(new ValueListItem(5, "Grains/Cereals"));
            v_list.ValueListItems.Add(new ValueListItem(6, "Meat/Poultry"));
            v_list.ValueListItems.Add(new ValueListItem(7, "Produce"));
            v_list.ValueListItems.Add(new ValueListItem(8, "Seafood"));


            ultraGrid1.DisplayLayout.Bands[0].Columns["CategoryID"].ValueList = v_list;
            ultraGrid1.DisplayLayout.Bands[0].Columns["CategoryID"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;

        }

        private DataTable CreateProducts()
        {
            DataTable dtData = new DataTable("Products");

            dtData.Columns.Add("ProductID", typeof(int));
            dtData.Columns["ProductID"].Unique = true;
            dtData.Columns["ProductID"].AutoIncrement = true;
            dtData.Columns["ProductID"].AutoIncrementStep = 1;
            dtData.PrimaryKey = new DataColumn[] { dtData.Columns["ProductID"] };

            dtData.Columns.Add("ProductName", typeof(String));
            dtData.Columns.Add("SupplierID", typeof(int));
            dtData.Columns.Add("CategoryID", typeof(int));
            dtData.Columns.Add("QuantityPerUnit", typeof(String));
            dtData.Columns.Add("UnitPrice", typeof(Decimal));
            dtData.Columns.Add("UnitsInStock", typeof(short));
            dtData.Columns.Add("UnitsOnOrder", typeof(short));
            dtData.Columns.Add("ReorderLevel", typeof(short));
            dtData.Columns.Add("Discontinued", typeof(Boolean));

            dtData.Rows.Add(new object[] { 1, "Chai", 1, 1, "10 boxes x 20 bags", 18.0, 39, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 2, "Chang", 1, 1, "24 - 12 oz bottles", 19.0, 17, 40, 25, 0 });
            dtData.Rows.Add(new object[] { 3, "Aniseed Syrup", 1, 2, "12 - 550 ml bottles", 10.0, 13, 70, 25, 0 });
            dtData.Rows.Add(new object[] { 4, "Chef Anton's Cajun Seasoning", 2, 2, "48 - 6 oz jars", 22.0, 53, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 5, "Chef Anton's Gumbo Mix", 2, 2, "36 boxes", 21.35, 0, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 6, "Grandmas Boysenberry Spread", 3, 2, "12 - 8 oz jars", 25.0, 120, 0, 25, 0 });
            dtData.Rows.Add(new object[] { 7, "Uncle Bob's Organic Dried Pears", 3, 7, "12 - 1 lb pkgs.", 30.0, 15, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 8, "Northwoods Cranberry Sauce", 3, 2, "12 - 12 oz jars", 40.0, 0, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 9, "Mishi Kobe Niku", 4, 6, "18 - 500 g pkgs.", 97.0, 29, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 10, "Ikura", 4, 8, "12 - 200 ml jars", 31.0, 31, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 11, "Queso Cabrales", 5, 4, "1 kg pkg.", 21.0, 22, 30, 30, 0 });
            dtData.Rows.Add(new object[] { 12, "Queso Manchego La Pastora", 5, 4, "10 - 500 g pkgs.", 38.0, 86, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 13, "Konbu", 6, 8, "2 kg box", 6.0, 24, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 14, "Tofu", 6, 7, "40 - 100 g pkgs.", 23.25, 35, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 15, "Green Shouyu", 6, 2, "24 - 250 ml bottles", 15.50, 39, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 16, "Pavlova", 7, 3, "32 - 500 g boxes", 17.45, 29, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 17, "Alice Mutton", 7, 6, "20 - 1 kg tins", 39.00, 39, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 18, "Carnarvon Tigers", 7, 8, "16 kg pkg", 62.50, 42, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 19, "Teatime Chocolate Biscuits", 8, 3, "10 boxes x 12 pieces", 9.20, 25, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 20, "Sir Rodney's Marmalade", 8, 3, "30 gift boxes", 81.00, 40, 0, 0, 0 });

            dtData.AcceptChanges();
            return dtData;
        }

        private void ultraGrid1_AfterRowUpdate(object sender, RowEventArgs e)
        {
            e.Row.RefreshSortPosition();
            if (e.Row.ParentRow != null)
            {
                if (e.Row.ParentRow.IsGroupByRow)
                {
                    UltraGridGroupByRow groupByRow = e.Row.ParentRow as UltraGridGroupByRow;
                    UltraGridColumn v_column = groupByRow.Column;
                    if (e.Row.Cells[v_column].Value.ToString() != groupByRow.Value.ToString())
                    {
                        Debug.WriteLine("Row hasn't been moved to the correct group!!!");        
                    }
                }
            }
        }
    
    }
}
